// Smets, F., and R. Wouters. 2003. "An Estimated Stochastic Dynamic General Equilibrium Model of the Euro Area."
// Journal of the European Economic Association 1(5), pp. 1123-1175.

var  wf rkf zcapf pkf cf invef yf labf pinff emplf mc zcap rk pk c rf pf
inve y lab pinf w p empl r ygap b g ls sinv spinf sw kf qs k one  a interest y_obs c_obs inve_obs w_obs pinf_obs r_obs empl_obs;
   
   varexo ea eb els eqs einv epinf ew er eg ep;
   
parameters 
 calfa ctou cbeta cg  csadjcost  csadjlab csigma chab cprobw clandaw csigl cprobp cindw cindp cfc 
 czcap psy crpi crdpi crr cry crdy crhoa crhopi  crhob crhog crhols crhoqs msigma  kpi crhoinve crhow;
 
calfa       = 0.3;     //alpha
ctou        = 0.025;     //tau
cbeta       = 0.99;     //beta     
cg=0.18;     
psy=1.69;
csadjcost   = 6.771;  //phi_i
csigma      = 1.353;  //sigma_c
chab       = 0.573;  //hab
cprobw      = 0.737;   //xi_w
clandaw     = 1.5;     //lambda_w
csigl       = 2.3995;   //sigma_l
cprobp      = 0.9082;   //xi_p
cindw       = 0.763;   //gamma_w
cindp       = 0.469;   //gamma_p 
cfc         = 1.408;   //phi_y
czcap       = 0.169;   //czcap 
csadjlab    = 0.5990;   //xi_e, calvo employment
msigma      = 0.55;      //sigma_m
kpi         =  1.001;
// reaction function
crpi        = 1.6841;    //r_pie
crdpi       = 0.1398;    //r_dpi
crr         = 0.9613;    //rho
cry         = 0.0988;    // r_y
crdy        = 0.1586;    //r_dy

// AR(1) shocks
crhoa       = 0.823;      //rho_a
crhopi      = 0.924;      //rho_pb
crhob       = 0.579;     //rho_b    
crhog       = 0.949;     //rho_g
crhols      = 0.889;     //rho_l
crhoinve      = 0.927;     //rho_i
crhow         = 0;
crhoqs        =0;
//crhom         = 0.95;


model(linear);

#clandap=cfc;
#crk=(cbeta^(-1)) - (1-ctou);
#cq=crk/cbeta;
#cw = (calfa^calfa*(1-calfa)^(1-calfa)/(clandap*crk^calfa))^(1/(1-calfa));
#clk=((1-calfa)/calfa)*(crk/cw);
#cky=cfc*(clk)^(calfa-1);
#ccs=1-cg-ctou*cky;
#cinvs=ctou*cky;
#cwly=1-crk*cky;
#cmsigma=csigma/msigma;
#cap=((1+czcap)/czcap);

cf       = (chab/(1+chab))*cf(-1) + (1/(1+chab))*cf(+1) - ((1-chab)/((1+chab)*csigma))*(rf-pinff(1))+b ;
invef    =   (1/(1+cbeta))*((invef(-1) + cbeta*invef(+1)) + (1/csadjcost)*pkf) +0*eqs+ sinv;  //investment steady state//
pkf      = -rf + pinff(+1) +cq*rkf(1) +  (cbeta*(1-ctou))*pkf(1)+qs;  //equity premium eq//
kf      =   (1-ctou)*kf(-1) + ctou*invef(-1);
pinff    =   0*one;
pf       =   0*pf(-1) + pinff;   
0     =   calfa*rkf + (1-calfa)*wf - a;   //marginal cost//
wf       = (csigma/(1-chab))*(cf-chab*cf(-1)) + csigl*labf-ls;     
zcapf    =   cap * rkf  ;
labf       =   -wf+cap*rkf  + kf(-1);        
yf       =   ccs*cf + cinvs*invef + g;   //output eq 38//
yf       =   cfc*(calfa*kf(-1) + (1-calfa)*labf +calfa*zcapf + a);      //output eq 38//   
emplf    =   cbeta*emplf(+1) + ((1-cbeta*csadjlab)*(1-csadjlab)/csadjlab)*(labf - emplf);
one      =   0*one(-1);


c        =   (chab/(1+chab))*c(-1) + (1/(1+chab))*c(+1)- ((1-chab)/((1+chab)*csigma))*(r-pinf(+1))+b;
inve     =   (1/(1+cbeta))*((inve(-1) + cbeta*inve(+1)) + (1/csadjcost)*pk) +1*eqs+ sinv;  //investment function 32//
pk       =  -r +pinf(+1) + cq*rk(1) +  (cbeta*(1-ctou))*pk(1)+qs;   //equity premium 33//
k        =   (1-ctou)*k(-1) + ctou*inve(-1);
pinf     =   (1/(1+cbeta*cindp))*((cbeta)*(pinf(+1)) + (cindp)*(pinf(-1)) 
             + ((1-cprobp)*(1-cbeta*cprobp)/(cprobp))*( calfa*rk+(1-calfa)*w - a))+ep; 
mc       =   calfa*rk+(1-calfa)*w - a;   //marginal cost//
w        =  (1/(1+cbeta))*(cbeta*w(+1)+w(-1))+(cbeta/(1+cbeta))*(pinf(+1))-((1+cbeta*cindw)/(1+cbeta))*(pinf)+(cindw/(1+cbeta))
*(pinf(-1)) -(1/(1+cbeta))*(((1-cbeta*cprobw)*(1-cprobw))/(((1+(((1+clandaw)*csigl)/(clandaw))))*cprobw))*(w+ls-csigl*lab-(csigma/(1-chab))*(c-chab*c(-1)))+ ew;
 zcap =  cap* rk ;
lab       =   -w+cap*rk  + k(-1); 
y        =   ccs*c + cinvs*inve + g;      //output eq 38//
y        =   cfc*(calfa*k(-1) + (1-calfa)*lab + a + calfa*zcap);    //output eq 38//     
p        =   0*p(-1) + pinf;
empl     =  cbeta*empl(+1)+ ((1-cbeta*csadjlab)*(1-csadjlab)/csadjlab)*(lab - empl);
ygap     =   y - yf;
r = crr*r(-1) + (1-crr)*(spinf+crpi*(pinf(-1)-spinf)+cry*ygap)+crdpi*(pinf-pinf(-1))+crdy*(ygap-ygap(-1))+er;
//mp      =   cmsigma*(c-chab*c(-1))-(msigma*r)+mds;
interest= r*4;
a        =   crhoa*a(-1) + ea;
b        =   crhob*b(-1) + eb;
g        =   crhog*g(-1) + eg;
ls       =   crhols*ls(-1) + els;
qs       =   crhoqs*qs(-1) + eqs;
sinv     =   crhoinve *sinv(-1) + einv;
spinf    =   crhopi*spinf(-1) + epinf;
//mds      =   crhom*mds(-1)+emds;
sw       =    crhow*sw(-1)+ew;


%%%%%%%%%%%%%%%%%%%%%%%%
%%Measurment equations%%
%%%%%%%%%%%%%%%%%%%%%%%%
y_obs=y;
c_obs=c;
w_obs=w;
inve_obs=inve;
r_obs=r;
pinf_obs=pinf;
empl_obs=empl;
end;
 

shocks;
var ea; stderr 0.598;
var eb; stderr 0.336;
var eg; stderr 0.325;
var einv; stderr 0.085;
var els; stderr 3.52;
var ew; stderr 0.289;
var eqs; stderr 0.603;
var epinf; stderr 0.016;
//var emds; stderr 0.041;
var ep; stderr 0.16;
var er; stderr 0.081;
end;

estimated_params;
stderr ea,0.4582,0.1,2,INV_GAMMA_PDF,0.4,2;
stderr eb,0.3686,0.01,2,INV_GAMMA_PDF,0.2,2;
stderr eg,0.3309,0.01,2,INV_GAMMA_PDF,0.3,2;
stderr eqs,0.5588,0.01,2,INV_GAMMA_PDF,0.1,2;
stderr epinf,0.012,0.01,2,INV_GAMMA_PDF,0.1,2;
stderr els,1.0872,1,5,INV_GAMMA_PDF,1,2;
stderr einv,0.0351,0.01,2,INV_GAMMA_PDF,0.1,2;
stderr er,0.7181,0.01,2,INV_GAMMA_PDF,0.1,2;
stderr ew,0.7181,0.01,2,INV_GAMMA_PDF,0.1,2;
stderr ep,0.2569 ,0.01,2,INV_GAMMA_PDF,0.1,2;
crhoa,0.7697 ,.1,.9999,BETA_PDF,0.85,0.10;
crhob,0.1578,.1,.99,BETA_PDF,0.85,0.10;
crhog,0.3385,.1,.9999,BETA_PDF,0.85,0.10;
crhols,0.800,.1,.99,BETA_PDF, 0.85,0.1;
crhoinve, 0.7670,.01,.99,BETA_PDF, 0.85,0.1;
crhopi, 0.9751 ,.1,.99,BETA_PDF, 0.85,0.1;
csadjcost,4.6531,1,15,NORMAL_PDF,4,1.5;
csigma,2.7521,0.25,3,NORMAL_PDF,1.50,0.375;
chab,0.3749,0.001,0.99,BETA_PDF,0.7,0.1;
cprobw,0.5811,0.3,0.95,BETA_PDF,0.5,0.1;
csigl,2.0387,0.25,10,NORMAL_PDF,2,0.75;
cprobp,0.5649,0.5,0.95,BETA_PDF,0.75,0.1;
csadjlab,0.8681,0.01,0.99,BETA_PDF,0.5,0.15;
cindw,0.6295,0.01,0.99,BETA_PDF,0.5,0.15;
cindp,0.3465,0.01,0.99,BETA_PDF,0.5,0.15;
czcap,0.1872,0.01,1,BETA_PDF,0.2,0.075;
cfc,1.1734,1.0,3,NORMAL_PDF,1.25,0.125;
crpi,1.4126,1.0,3,NORMAL_PDF,1.5,0.25;
crdpi,0.4286,0.001,0.5,NORMAL_PDF,0.3,0.1;
crr,0.5917 ,0.5,0.975,BETA_PDF,0.85,0.10;
cry, 0.1671,0.001,0.5,NORMAL_PDF,0.125,0.05;
crdy, 0.1315,0.001,0.5,NORMAL_PDF,0.0625,0.05;
calfa, 0.3370,0.01,1.0,NORMAL_PDF,0.3,0.05;
end;






varobs y_obs c_obs inve_obs w_obs pinf_obs r_obs empl_obs; 
//identification; dynare_sensitivity(identification=1,morris=2);
estimation(datafile=sw2003data1,mode_compute=6,first_obs=1,presample=4, prefilter=0,mh_replic=2000, mh_nblocks=5,mh_jscale=0.4,mh_drop=0.2);

 
//stoch_simul (irf = 0, ar=100, noprint);
//stoch_simul(periods=200,irf=20) y c pinf interest w rk mc empl inve;
//estimation(datafile=swdata,mode_compute=4,first_obs=143,presample=4,bayesian_irf, prefilter=0,mh_replic=1000,mh_nblocks=2,mh_jscale=0.40,mh_drop=0.2);
//options_.plot_priors=0  mode_check,   mode_file=newtest_mode, mode_file=newtest_mh_mode,;